#ifndef __PACKAGES__
#include <Packages.h>
#endif

#include "ResEd.h"

/*
File FMAT.h
by Michael Hecht (Michael_Hecht@mac.sas.com)
July 14, 1993

based on material
	Copyright Apple Computer, Inc. 1985-1990
	All rights reserved.

	Some modifications by Erik A. Johnson (johnsone@uxh.cso.uiuc.edu) for
	THINK C (5.0.1).
*/

#define RESOURCE_TYPE		'FMAT'
#define RESOURCE_STRING		"\pFormat"

#define ResID( n )			(ResEdID()*10 + (n))

void _PStrCopy( ConstStr255Param src, StringPtr dest );
void _PStrCat( ConstStr255Param pend, StringPtr dest );

enum {
	tokPEPlus = tokMaxSymbols + 1, tokPEMinus, tokPEMinusPlus,
	kNumPaletteButtons
};

enum {
	kNumberPartsStringID = 1,
	kLiteralStr = 1, kSignsStr, kDigitsStr, kThousandsStr, kDecPointStr,
	kPercentStr, kEscapeStr, kSeparatorStr, kExponentsStr, kUnquotedStr,
	kNumPaletteStaticText
};

typedef struct {
	FloatingWindowRec	fw;

	Rect				buttonList[ kNumPaletteButtons - 1 ];
	Point				staticTextList[ kNumPaletteStaticText - 1 ];
} NumberPartsPalette, **NumberPartsPaletteHandle;


typedef NumFormatString FMATRec, *FMATPtr, **FMATHandle;

#define	sizeOfFMATResource	((long)sizeof(FMATRec))

typedef struct {
	ParentRec		w;

	NumberPartsPaletteHandle	thePalette;
	NumberParts		partsTable;
	NumFormatString	curFormat;
	FormatStatus	curStatus;
	TripleInt		curPositions;
	Boolean			curPosValid;
	Str255			originalFmtStr;
	short			originalFmtScript;
	TripleInt		originalPositions;
	Str255			positiveExample, negativeExample, zeroExample;
	
} rFMATRec, *rFMATPtr, **rFMATHandle;


void UpdateExamples( rFMATHandle myFMAT );

NumberPartsPaletteHandle NewNumberPartsPalette( rFMATHandle myFMAT );
void InitNumberPartsPalette( NumberPartsPaletteHandle thePalette, NumberParts *parts,
							short parentFont );
void UpdatePalette( NumberPartsPaletteHandle thePalette );
void ClickPalette( EventRecord *evt, NumberPartsPaletteHandle thePalette );
void CloseNumberPartsPalette( NumberPartsPaletteHandle thePalette );
